{-# LANGUAGE NoMonomorphismRestriction #-}
module Control.Concurrent.Session.Queens where

import Control.Concurrent.Session

st = cons (select ((D1 E) ~|~
                   (D1 E) ~|~
                   (D2 E) ~|~ nil)) $
     cons (sendPid (cons (D0 E, TT) $ cons (D3 E, FF) $ cons (D3 E, TT) $ cons (D4 E, TT) nil) ~> jump (D0 E)) $
     cons (end) $
     cons (Send (int, int) ~> end) $
     cons (RecvBool ~> end)
     nil
    where
      int = undefined :: Int

makeQueens [] pids
    = sreturn pids
makeQueens (coord:coords) pids
   = forkThenClose (D3 E) FF childSessions queen (ssend coord) ~>>= \((), pid) ->
     makeQueens coords (pid:pids)
    where
      childSessions = cons (D0 E, TT) $ cons (D3 E, FF) $ cons (D3 E, TT) $ cons (D4 E, TT) nil

      queen rootCoordCh rootPid
          = withThenClose rootCoordCh srecv ~>>= \(x, y) ->

            createSessionThenClose (D0 E) TT rootPid (receivePids [] [])  ~>>= \(beforePids, afterPids) ->

            (smapM_
             (\p -> createSessionThenClose (D3 E) FF p (ssend (x, y))) afterPids) ~>>

            (smapM
             (\p -> createSessionThenClose (D3 E) TT p srecv) beforePids) ~>>= \beforeCoords ->

            createSessionThenClose (D4 E) TT rootPid (ssend . or . map (detectCollision (x, y)) $ beforeCoords)
            where
              receivePids beforePids afterPids
                  = soffer ( (srecv ~>>= \beforePid ->
                              sjump ~>> receivePids (beforePid:beforePids) afterPids
                             ) ~||~
                             (srecv ~>>= \afterPid ->
                              sjump ~>> receivePids beforePids (afterPid:afterPids)
                             ) ~||~
                             (sreturn (afterPids, reverse beforePids))
                             ~||~ OfferImplsNil
                           )

              detectCollision (x, y) (x', y') = x == x'
                                             || y == y'
                                             || (abs (x' - x)) == (abs (y' - y))

sendPids 0 [] = sselect (D2 E) ~>> sreturn ()
sendPids 0 (pid:pids) = sselect (D1 E) ~>>
                        ssend pid ~>>
                        sjump ~>>
                        sendPids 0 pids
sendPids n (pid:pids) = sselect (D0 E) ~>>
                        ssend pid ~>>
                        sjump ~>>
                        sendPids (n-1) pids

distributePids 0 _ = sreturn ()
distributePids n (pid:pids)
    = createSessionThenClose (D0 E) FF pid (sendPids (n - 1) pids) ~>>
      distributePids (n-1) (pids ++ [pid])

gatherResults [] = sreturn False
gatherResults (pid:pids)
    = createSessionThenClose (D4 E) FF pid srecv ~>>= \collision ->
      gatherResults pids ~>>= \collisions ->
      sreturn (collision || collisions)

hasCollision lst = runInterleaved (cons (D0 E, FF) $ cons (D4 E, FF) nil) st
                   (makeQueens lst [] ~>>= \pids ->
                    distributePids (length lst) pids ~>>
                    gatherResults pids
                   )
--hasCollision [(1,1), (2,7), (3,4), (4,6), (5,8), (6,2), (7,5), (8,3)] ==> False
